import { PuthPlugin, PuthPluginGeneric } from './src/PuthPluginGeneric';
import PuthContextPlugin from './src/PuthContextPlugin';
import PuthInstancePlugin from './src/PuthInstancePlugin';
export declare class Puth {
    private contexts;
    private contextPlugins;
    private instancePlugins;
    private server;
    private options;
    constructor(options?: any);
    use(plugin: PuthPluginGeneric<PuthPlugin>): void;
    isDebug(): boolean;
    isSilent(): boolean;
    isDev(): boolean;
    serve(port?: number, address?: string, log?: boolean): Promise<void>;
    log(level?: string, ...args: any[]): void;
    contextCreate(options?: {}): Promise<{
        id: string;
        type: string;
        test: string | undefined;
        group: string | undefined;
    }>;
    contextCall(packet: any): Promise<any>;
    contextGet(packet: any): Promise<{
        type: string;
        value: any;
    } | {
        type: string;
        code: string;
        message: string;
    }>;
    contextSet(packet: any): Promise<{
        type: string;
        code: string;
        message: string;
    } | undefined>;
    contextDelete(packet: any): Promise<{
        type: string;
        code: string;
        message: string;
    } | undefined>;
    private setupFastify;
    getContextPlugins(): PuthPluginGeneric<PuthContextPlugin>[];
    getInstancePlugins(): PuthInstancePlugin[];
    getServer(): any;
}
export default function puth(options?: any): Puth;
