import * as puppeteer from 'puppeteer';
import Generic from './Generic';
import { ICommand } from './Snapshots';
import { Puth } from '../Server';
import PuthContextPlugin from './PuthContextPlugin';
import { Browser } from 'puppeteer';
export declare enum Capability {
    EVAL = "EVAL"
}
declare class Context extends Generic {
    private readonly id;
    private readonly type;
    private readonly emitter;
    private readonly puth;
    private options;
    private plugins;
    private instance;
    private eventFunctions;
    private capabilities;
    tracked: {
        dialogs: Map<puppeteer.Page, [string, string]>;
    };
    constructor(puth: Puth, options?: any);
    setup(): Promise<void>;
    connectBrowser(options: any): Promise<puppeteer.Browser>;
    createBrowser(options?: {}): Promise<puppeteer.Browser | undefined>;
    isDev(): boolean;
    getDaemonBrowser(options?: any): Promise<puppeteer.Browser | undefined>;
    _trackBrowser(browser: Browser | undefined): Promise<void>;
    destroy(): Promise<boolean>;
    _trackPage(page: any): void;
    _trackDialogs(page: any): Promise<void>;
    registerEventListenerOn(object: any, event: any, func: any): void;
    removeEventListenersFrom(object: any): void;
    unregisterAllEventListeners(): void;
    _cleanPage(page: any): Promise<void>;
    setCapability(capability: any, value: true | false): void;
    hasCapability(capability: Capability): boolean;
    fail(): void;
    shouldSnapshot(): boolean;
    createCommand(packet: any, on: any): Promise<ICommand | undefined>;
    call(packet: any): Promise<any>;
    handleCallApply(packet: any, page: any, command: any, on: any, func: any, parameters: any, expects?: any): Promise<any>;
    handleCallApplyAfter(packet: any, page: any, command: any, returnValue: any, expectation?: any): Promise<any>;
    resolveReturnValue(action: any, returnValue: any): any;
    get(action: any): Promise<{
        type: string;
        value: any;
    } | {
        type: string;
        code: string;
        message: string;
    }>;
    set(action: any): Promise<{
        type: string;
        code: string;
        message: string;
    } | undefined>;
    delete(action: any): Promise<{
        type: string;
        code: string;
        message: string;
    } | undefined>;
    resolveOn(representation: any): Context | any;
    resolveIfCached(representation: any): any;
    getId(): string;
    getType(): string;
    serialize(): {
        id: string;
        type: string;
        test: string | undefined;
        group: string | undefined;
    };
    getTest(): string | undefined;
    getGroup(): string | undefined;
    getPuth(): Puth;
    getPlugins(): PuthContextPlugin[];
    emit(...args: any[]): any;
    off(...args: any[]): any;
    on(...args: any[]): any;
    getTimeout(options?: any): any;
}
export default Context;
